Unit uGUI;


/////////////////////////////////// Interface //////////////////////////////////
Interface

Uses    Windows, Messages, SysUtils, System.IOUtils, Variants, Classes, Graphics, Controls, Forms,
        Dialogs, StdCtrls, Grids, DBGrids, DB, DBClient, Vcl.ExtCtrls,
        Vcl.DBCtrls, Vcl.Buttons, WEBLib.ExtCtrls, ColorButton, kbmMemTable,
  kbmMemCSVStreamFormat, kbmMemBinaryStreamFormat, Vcl.WinXCtrls;




Type    TGUI    = Class (TForm)
    DBGrid1             : TDBGrid;
    BtnClear            : TButton;
    BtnIdx              : TButton;
    OpenDialog1         : TOpenDialog;
    SaveDialog1         : TSaveDialog;
    SaveDialog2         : TSaveDialog;
    BtnSaveC            : TButton;
    Panel1              : TPanel;
    BtnCreateNewField   : TButton;
    Edit1               : TEdit;
    ComboBox1           : TComboBox;
    Edit3               : TEdit;
    Panel2              : TPanel;
    EdtAddField         : TEdit;
    ComboBox2           : TComboBox;
    EdtAddSize          : TEdit;
    CDS1: TClientDataSet;
    DS1: TDataSource;
    DBGrid2: TDBGrid;
    DS2: TDataSource;
    Panel5: TPanel;
    Panel4: TPanel;
    Panel3: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    ClrBtnImportLoad: TColorButton;
    ClrBtnFieldDef: TColorButton;
    ClrBtnAddNewField: TColorButton;
    ClrBtnExportData: TColorButton;
    ClrBtnExportSave: TColorButton;
    ClrBtnReset: TColorButton;
    ClrBtnHelp: TColorButton;
    ClrBtnClose: TColorButton;
    ClrBtnTest: TColorButton;
    CDS2: TClientDataSet;
    ClrBtnSave: TColorButton;
    ClrBtnFirst: TColorButton;
    ClrBtnPrior: TColorButton;
    ClrBtnLast: TColorButton;
    ClrBtnNext: TColorButton;
    kbmMemTable1: TkbmMemTable;
    DBGrid3: TDBGrid;
    D3: TDataSource;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ColorButton1: TColorButton;
    ClrBtnSaveMemtableBIN: TColorButton;
    SaveDialog3: TSaveDialog;
    kbmCSVStreamFormat1: TkbmCSVStreamFormat;
    kbmBinaryStreamFormat1: TkbmBinaryStreamFormat;
    ActivityIndicator1: TActivityIndicator;
    ClrBtnSaveCSV: TColorButton;
    SaveDialog4: TSaveDialog;
    ColorButton2: TColorButton;

    Procedure BtnCreateNewFieldClick   (Sender : TObject);
    Procedure BtnClearClick    (Sender : TObject);
    Procedure BtnIdxClick      (Sender : TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure BtnSaveCClick(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ClrBtnImportLoadClick(Sender: TObject);
    procedure ClrBtnFieldDefClick(Sender: TObject);
    procedure ClrBtnAddNewFieldClick(Sender: TObject);
    procedure ClrBtnExportDataClick(Sender: TObject);
    procedure ClrBtnExportSaveClick(Sender: TObject);
    procedure ClrBtnResetClick(Sender: TObject);
    procedure ClrBtnHelpClick(Sender: TObject);
    procedure ClrBtnCloseClick(Sender: TObject);
    procedure ClrBtnTestClick(Sender: TObject);
    procedure ClrBtnSaveClick(Sender: TObject);
    procedure ClrBtnFirstClick(Sender: TObject);
    procedure ClrBtnNextClick(Sender: TObject);
    procedure ClrBtnPriorClick(Sender: TObject);
    procedure ClrBtnLastClick(Sender: TObject);
    procedure ColorButton1Click(Sender: TObject);
    procedure ClrBtnSaveMemtableBINClick(Sender: TObject);
    procedure ColorButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ClrBtnSaveCSVClick(Sender: TObject);
    procedure ColorButton2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure EdtAddFieldChange(Sender: TObject);
    procedure EdtAddSizeChange(Sender: TObject);

    Private
    Public
    End;

Var     GUI     : TGUI;

    AddFieldName, NwFieldName : string;
    AddFieldKind, NwFieldKind : TFieldType;
    AddFieldSize, NwFieldSize : Integer;
    ColumnLast                : Integer;
    ColumTitleString, CDS_Filename : String;



/////////////////////////////// Implementation /////////////////////////////////

Implementation

{$R *.dfm}
///////////////////////////////////// Form /////////////////////////////////////

procedure TGUI.FormCreate(Sender: TObject);
Var Compiledate : String; aDate : TDateTime;
begin
  // Compiledate:=DateTimeToStr(FileDateToDateTime(FileAge(ExtractFileName(Application.ExeName))));
  // Deprecated  so this is the best way to do it: use function Exedate

  if FileAge(Application.ExeName,adate) then
    CompileDate:=DateTimeToStr(aDate)
  else CompileDate:='?';

  Caption := 'COMPILE DATE:' + ' ' +Compiledate +'     '
        + '  Path ' + ExtractFilePath(Application.ExeName) ; // Path

 ClrBtnTest.Visible := False;
 ClrBtnSave.Visible := False;
 ClrBtnFirst.Visible := False;
 ClrBtnNext.Visible := False;
 ClrBtnPrior.Visible := False;
 ClrBtnLast.Visible := False;
 Width := 250;

end;

Procedure TGUI.BtnCreateNewFieldClick (Sender : TObject);
Begin
   if Edit1.text = '' then
   if ComboBox1.itemindex = -1 then
     if Edit3.text = '' then
     begin
       BtnCreateNewField.Enabled:= false;
     end;

  Cds1.Close;
  // Dependant on choice 1 new datset
  ClrBtnImportLoad.Enabled:= False;
  Gui.ShowHint := False;
  // Check if Edit1 contains text
  if Edit1.Text <= '' then
    begin
      Showmessage('You must give a name for the field');
      BtnCreateNewField.Enabled:=False;
    end
  else
    begin
      BtnCreateNewField.Enabled := True;
      // Check if Combobox contaisn a field type
      if ComboBox1.Text <= ''
      then Showmessage('Please select a field kind')
      else
      // Check if Edit3 contains teh field size
      If Edit1.Text <= '' then Showmessage('Please select a field size');
      // The boolean set at the end is already set to true
      // It is required by the syntax
    end;

  NwFieldName := Edit1.Text;
  NwFieldKind := TFieldType(ComboBox1.ItemIndex);
  NwFieldSize := StrToInt(Edit3.Text);

  CDS1.FieldDefs.Add (NwFieldName, NwFieldKind, NwFieldSize, True);
  // CDS1.FieldDefs.Add ('NAAM',   ftString,    20,          True);

  CDS1.CreateDataSet;

  BtnSaveC.Enabled := true;
  BtnClear.Enabled := true;
End;


procedure TGUI.BtnSaveCClick(Sender: TObject);
begin
  if SaveDialog1.Execute then ShowMessage('File : ' + SaveDialog1.FileName);
  CDS1.SaveToFile(SaveDialog1.FileName);

  Edit1.Enabled := False;
  Edit3.Enabled := False;
  ComboBox1.Enabled := False;
  ClrBtnImportLoad.Enabled := True;
end;

procedure TGUI.Button1Click(Sender: TObject);
begin
  Panel5.Visible := False;
end;

procedure TGUI.ClrBtnImportLoadClick(Sender: TObject);
begin
  DBGrid1.Visible := True;

  if OpenDialog1.Execute then
  // ShowMessage('File : ' + openDialog1.FileName);
  CDS1.LoadFromFile(openDialog1.FileName);//
  CDS_Filename := OpenDialog1.FileName;

  ClrBtnFieldDef.Enabled := True;
  ClrBtnImportLoad.Enabled := False;
  ClrBtnReset.Enabled:= True;
  ColorButton1.Enabled:= True;

  width:= 1388;
end;

procedure TGUI.ClrBtnFieldDefClick(Sender: TObject);
begin
  CDS2.FieldDefs.Assign (CDS1.FieldDefs);
  CDS2.CreateDataSet;
  kbmMemTable1.FieldDefs.Assign (CDS1.FieldDefs);
  kbmMemTable1.Active:= true;

  EdtAddField.Enabled:= true;
  ComboBox2.Enabled:= true;
  EdtAddSize.Enabled:= true;
  BtnIdx.Enabled := True;

  ColorButton1.Enabled:= True;
  DBGrid2.visible := True;
end;

procedure TGUI.ClrBtnAddNewFieldClick(Sender: TObject);
begin
   CDS2.Close;
   AddFieldName :=  EdtAddField.Text;                  // reeds the fieldname
   AddFieldKind :=  TFieldType(ComboBox2.ItemIndex);   // reeds the fieldkind by the index number of the combobox
   AddFieldSize :=  StrToInt(EdtAddSize.Text);         // reeds the fieldsize

  // The simple way:
  // CDS2.FieldDefs.Add ('ID',   ftInteger, 0, False);

   CDS2.FieldDefs.Add (AddFieldName, AddFieldKind, AddFieldSize, False);
   CDS2.CreateDataSet;

   ClrBtnExportData.Enabled := True;
   ClrBtnExportSave.Enabled := True;

    ClrBtnReset.Enabled := True;
end;

procedure TGUI.ClrBtnExportDataClick(Sender: TObject);
Var     I : Integer;
Begin
  DBGrid1.Visible := False;
  DBGrid2.Visible := False;
  DBGrid3.Visible := False;
  CDS1.First;

  While Not CDS1.Eof Do
  Begin
    CDS2.Append;

   // For I := 0 To CDS1.FieldCount - 1 Do CDS2.Fields [I].Assign (CDS1.Fields [I]);
    For I := 0 To CDS1.FieldCount - 1 Do
    begin
     CDS2        .Fields [I].Assign (CDS1.Fields [I]);
    end;
     CDS2.Post;

    CDS1.Next

  End;
  CDS1.First;
  CDS2.First;

 DBGrid1.Visible := True;
 DBGrid2.Visible := True;
 DBGrid3.Visible := True;

 ClrBtnTest.Visible := True;
 ClrBtnSave.Visible := True;
 ClrBtnFirst.Visible := True;
 ClrBtnNext.Visible := True;
 ClrBtnPrior.Visible := True;
 ClrBtnLast.Visible := True;
 ClrBtnReset.Enabled := True;

end;

procedure TGUI.ClrBtnExportSaveClick(Sender: TObject);
begin
  if SaveDialog2.Execute then ShowMessage('File : ' + SaveDialog2.FileName);
  CDS2.SaveToFile(SaveDialog2.FileName);
  ClrBtnReset.Enabled := True;
end;

procedure TGUI.ClrBtnResetClick(Sender: TObject);
begin
  CDS1.Close;
  CDS2.Close;

  DBGrid1.Visible := False;
  DBGrid2.Visible := False;

  EdtAddField.Text := '';
  ComboBox2.Text := '';
  EdtAddSize.Text := '';

  ClrBtnAddNewField.Enabled := False;
  ClrBtnExportData.Enabled := False;
  ClrBtnExportSave.Enabled := False;
  ClrBtnFieldDef.Enabled := False;

  BtnIdx.Enabled := False;
  ColorButton1.Enabled := False;
  Edit1.Enabled := False;
  Edit3.Enabled := False;
  ComboBox1.Enabled := False;
  ClrBtnImportLoad.Enabled := True;

  width:= 250;
end;

procedure TGUI.ClrBtnTestClick(Sender: TObject);
begin
  ColumnLast := dbgrid2.Columns.Count;
  DBGrid2.SelectedIndex := (ColumnLast);
  CDS2.Edit;
end;

procedure TGUI.ClrBtnSaveClick(Sender: TObject);
begin
  With CDS2 do
    begin
      Post;
      MergeChangeLog;
      SaveToFile(CDS_Filename);  // global Var = extracted from OpenDialog1
    end;
end;

procedure TGUI.ClrBtnHelpClick(Sender: TObject);
begin
  Panel5.Visible := Not Panel5.Visible ;
end;

procedure TGUI.ClrBtnFirstClick(Sender: TObject);
begin
  With CDS2 do
  if active then
    begin
      showmessage('active');
      First
    end
    else
      begin
      showmessage(' not active');
      exit;
    end
end;

procedure TGUI.ClrBtnNextClick(Sender: TObject);
begin
  With CDS2 do
  if active then
    begin
      showmessage('active');
      Next
    end
    else
      begin
      showmessage(' not active');
      exit;
    end
end;

procedure TGUI.ClrBtnPriorClick(Sender: TObject);
begin
 With CDS2 do
  if active then
    begin
      showmessage('active');
      Prior
    end
    else
      begin
      showmessage(' not active');
      exit;
    end
end;

procedure TGUI.ClrBtnLastClick(Sender: TObject);
begin
 With CDS2 do
  if active then
    begin
      showmessage('active');
      Last
    end
    else
      begin
      showmessage(' not active');
      exit;
    end
end;

procedure TGUI.ColorButton1Click(Sender: TObject);
Var     I : Integer;
Begin
  ClrBtnSaveMemtableBIN.Enabled := True;
  ClrBtnSaveCSV.Enabled := True;

  DBGrid1.Visible := False;
  DBGrid2.Visible := False;
  DBGrid3.Visible := False;

  kbmMemTable1.FieldDefs.Assign (CDS1.FieldDefs);
  kbmMemTable1.Active:= true;


  CDS1.First;


  While Not CDS1.Eof Do
  Begin
    kbmMemTable1.Active := true;
    kbmMemTable1.Append;
    For I := 0 To CDS1.FieldCount - 1 Do
    begin
      kbmMemTable1.Fields [I].Assign (CDS1.Fields [I]);
    end;
      kbmMemTable1.Post;

      CDS1.Next

  End;
  kbmMemTable1.First;

  DBGrid1.Visible := True;
  DBGrid3.Visible := True;

end;

procedure TGUI.ColorButton1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ActivityIndicator1.Animate := True;
end;

procedure TGUI.ColorButton2Click(Sender: TObject);
begin

  Edit1.Enabled := True;
  Edit3.Enabled := True;
  ComboBox1.Enabled := True;
  ClrBtnImportLoad.Enabled := False;
  ClrBtnReset.Enabled := True;
  width:= 1388  ;
end;

procedure TGUI.ClrBtnSaveMemtableBINClick(Sender: TObject);
begin
  if SaveDialog3.Execute then
    kbmMemTable1.SaveToFileViaFormat(SaveDialog3.FileName, kbmBinaryStreamFormat1);
    // you need to add the component kbmBinaryStreamFormat1

end;

procedure TGUI.ClrBtnSaveCSVClick(Sender: TObject);
begin
  if SaveDialog4.Execute then
    kbmMemTable1.SaveToFileViaFormat(SaveDialog4.FileName, kbmCSVStreamFormat1);
    // you need to add the component or the component kbmCSVStreamFormat1
end;

procedure TGUI.ComboBox1Change(Sender: TObject);
begin
 // NwFieldKind := TFieldType(ComboBox1.ItemIndex);

  if TFieldType(ComboBox1.ItemIndex) = ftinteger then Edit3.Text:= '0';

  if Edit1.text > '' then
    if ComboBox1.itemindex > -1 then
      if Edit3.text > '' then BtnCreateNewField.Enabled:= True;

end;

procedure TGUI.ComboBox2Change(Sender: TObject);
begin
  AddFieldKind := TFieldType(ComboBox2.ItemIndex);

 if EdtAddField.text > '' then
   if ComboBox2.itemindex > -1 then
     if EdtAddSize.text > '' then ClrBtnAddNewField.Enabled:= True;
end;


procedure TGUI.Edit1Change(Sender: TObject);
begin
  if Edit1.text > '' then
    if ComboBox1.itemindex > -1 then
     if Edit3.text > '' then BtnCreateNewField.Enabled:= True;
end;

procedure TGUI.Edit3Change(Sender: TObject);
begin
  if Edit1.text > '' then
   if ComboBox1.itemindex > -1 then
     if Edit3.text > '' then
     begin
       BtnCreateNewField.Enabled:= True;

       ClrBtnImportLoad.Enabled:= false;
     end;
end;

procedure TGUI.EdtAddFieldChange(Sender: TObject);
begin
  if EdtAddField.text > '' then
    if ComboBox2.itemindex > -1 then
      if EdtAddSize.text > '' then ClrBtnAddNewField.Enabled:= True;
end;

procedure TGUI.EdtAddSizeChange(Sender: TObject);
begin
  if EdtAddField.text > '' then
   if ComboBox2.itemindex > -1 then
     if EdtAddSize.text > '' then
     begin
       ClrBtnAddNewField.Enabled:= True;
       ClrBtnExportData.Enabled := false;
     end;
end;

Procedure TGUI.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Edit1.Text > '' then
    if ComboBox1.Text > '' then
      if Edit3.Text > '' then BtnCreateNewField.Enabled:=True;
end;

Procedure TGUI.BtnClearClick (Sender : TObject);
Begin
  CDS1.EmptyDataSet;
  Edit1.Enabled := False;
  Edit3.Enabled := False;
  ComboBox1.Enabled := False;
  ClrBtnImportLoad.Enabled := False;
End;


Procedure TGUI.BtnIdxClick(Sender: TObject);
Var I : Integer;
Begin
   I := 1;
   CDS2.First;
   While Not CDS2.Eof Do
   Begin
      CDS2.Edit;
     // The simple way
      CDS2.FieldByName ('ID').AsInteger := I;

      CDS2.Post;
      CDS2.Next;
      Inc (I);
   End;
End;

procedure TGUI.ClrBtnCloseClick(Sender: TObject);
begin
  Application.Terminate
end;

////////////////////////////////// End ///////////////////////////////////////

End.
